/* Specification:
Created/Revised by Barbara Williams on Septemeber 19, 2010
Ch. 13 Lab 3
This lab writes a program that contains a Time class that implements the time of day
in a program. Time class is extended to include a third data member in which time 
zone is stored. The derived class is called extTime with all the necessary function
definitions and constructors to make the class functional. The program includes a
test program (main) to test the inherited class features.*/

//Required by cout command
#include <iostream>

//Required by ifstream for file input and objects of ofstream for file output
#include <fstream>

//Required by string data type
#include <string>

// Time header file - Required by class
#include "Time.h"

// extTime header file - Required by class
#include "extTime.h"

// Default namespace defining library functions (e.g. cout, endl)
using namespace std;

int main()
{
	// instantiate object in Time class
	Time firstTime;
	
	// instantiate object in extTime class
	extTime secondTime;
	
	cout << "Time object time starts our = ";
	//call getTime through printTime method in Time class
	firstTime.printTime();
	cout << endl;
	
	cout << "doTest<> with Time class object: " << endl;
	cout << "Initially time = ";
	// call printTime method in Time class
	firstTime.printTime();
	cout << endl;
	
	cout << "After setting time = ";
	// call setTime method in Time class
	firstTime.setTime(5,57);
	// call printTime method in Time class
	firstTime.printTime();
	cout << endl;
	
	cout << "After incrementing time = ";
	//call incrementTime method in Time class
	firstTime.incrementTime();
	//call printTime method in Time class
	firstTime.printTime();
	cout << endl;
	
	cout << "After decrementing time = ";
	// call decrementTime method in Time class
	firstTime.decrementTime();
	//call printTime method in Time class
	firstTime.printTime();
	cout << endl << endl;
	
	cout << "extTime object time starts out = ";
	//call printTime method in extTime class
	secondTime.printTime();
	cout << endl;
	
	cout << "doTest<> with an extTime class object: " << endl;
	cout << "Initially time = ";
	// call printTime method in extTime class
	secondTime.printTime();
	cout << endl;
	
	cout << "After incrementing time = ";
	// call incrementTime method in Time class
	secondTime.incrementTime();
	// call printTime method in extTime class
	secondTime.printTime();
	cout << endl;
	
	cout << "After decrementing time = ";
	// call decrementTime method in Time class
	secondTime.decreementTime();
	//call printTime method in extTime class
	secondTime.printTime();
	cout << endl << endl;
	
	// call setTimeZone method in extTime class
	secondTime.setTimeZone("MST");
	cout << endl;
	cout << "After changing tz et = ";
	//call printTime method in extTime class
	cout << endl << endl;
	
	return 0;
}
	