/* Specification:
Created/Revised by Barbara Williams on Septemeber 19, 2010
Ch. 13 Lab 3
This lab writes a program that contains a Time class that implements the time of day
in a program. Time class is extended to include a third data member in which time 
zone is stored. The derived class is called extTime with all the necessary function
definitions and constructors to make the class functional. The program includes a
test program (main) to test the inherited class features.*/

/* Time.h the specification file for the class Time Class - "Time" contains 
five public member functions and two private integer member variable.*/

//Required by cout command
#include <iostream>

//Required by ifstream for file input and objects of ofstream for file output
#include <fstream>

//Required by string data type
#include <string>

// A preprocessor identifier means "if not defined TIME_H"
#ifndef TIME_H

// A preprocessor identifier means "defined TIME_H"
#define TIME_H

// Default namespace defining library functions (e.g. cout, endl)
using namespace std;

// base class
class Time
{
	public:
		/* A mutator method called setTime that takes two reference parameters and
		returns void. Function is to set the time. The time is set according to the
		parameter. Postconditions: hrs mins
		The function checks whether the value of hours and minutes is valid. If value
		is invalid the default value is assigned.*/
		void setTime(int hrs, int mins);
		
		/* An accessor method called getTime that takes two parameters and returns void.
		Function is to return the time. Postconditions: hrs mins */
		void getTime(int& hrs, int& mins);
		
		/* A constant method called printTime that takes no parameters, returns void and
		outputs the time. Function is to print the time. Postconditions: The time is 
		printed in the form of a string.*/
		void printTime() const;
		
		/* A method to increment the time that takes no parameters and returns void.
		Function is to add a number to the current hour (time). 
		Postcontions: hours++; minutes++;*/
		int incrementTime();
		
		/* An accessor method to decrement the time that takes no parameters and
		returns void. Function is to subtract a number from the current hour (time).
		Postconditions: hours--; minutes--;*/
		int decrementTime();
		
		/* Default constructor - Function is to assign zero to each of the data 
		members. The hour is set to "0" and minute is set to "0". 
		Postconditions: hour = 0; minute = 0; */
		Time();
		
		/* An overloaded constructor that takes two parameters. Function is to
		assign one to each data member. Postconditions: hours = 1;, minutes = 1;*/
		Time(int, int);
		
		/* Destructor - Function is automatically called when an object is destroyed, 
		either because its scope of existence has finished or because it is an object
		dynamically assigned and it is released using the operator delete. Postconditions: */
		~Time();
		
	private:
		//Data member (variable) to store the hour.
		int hours;
		
		//Data member (variable) to store the minutes.
		int minutes;
};

//a preprocessor identifier means "end if"
#endif
