/* Specification:
Created/Revised by Barbara Williams on Septemeber 19, 2010
Ch. 13 Lab 3
This lab writes a program that contains a Time class that implements the time of day
in a program. Time class is extended to include a third data member in which time 
zone is stored. The derived class is called extTime with all the necessary function
definitions and constructors to make the class functional. The program includes a
test program (main) to test the inherited class features.*/

/* TimeImp.cpp, the implementation file - The user program that uses Time class. */

// Required by cout command
#include <iostream>

//Required by ifstream for file input and objects of ofstream for file output
#include <fstream>

//Required by string data type
#include <string>

// Time header file - Required by class
#include "Time.h"

// Default namespace defining library functions (e.g. cout, endl)
using namespace std;

// Definitions of the member functions of the class Time.
// implementation of the constructor with parameters.
Time::Time(int hrs, int mins)
{
	if (0 <= hrs && hrs < 24)
		hrs = hours;
	else
		hrs = 0;
	
	if (0 <= mins && mins < 60)
		mins = minutes;
	else
		mins = 0;
}

// implementation of the destructor
Time::~Time()
{
}

// implementation of the default destructor
Time::Time()
{
	hours = 12;
	minutes = 0;
}

void Time::setTime(int hrs, int mins)
{
	if (0 <= hrs && hrs < 24)
		hours = hrs;
	else
		hours = 0;
	
	if (0 <= mins && mins < 60)
		minutes = mins;
	else
		minutes = 0;
}

void Time::getTime(int& hrs, int& mins)
{
	hrs = hours;
	mins = minutes;
}

void Time::printTime() const
{
	// places a zero in front of number if less than ten
	if (hours < 10)
		cout << "0";
	cout << hours << ":";
	
	// places a zero in front of number if less than ten
	if (minutes < 10)
		cout << "0";
	cout << minutes;
}

// Method to increment the time
int Time::incrementTime()
{
	// increases hours by one digit
	hours++;
	
	if (hours > 24)
		hours = 1;
		
	// increases minutes by one digit
	minutes++;
	
	if (minutes > 59)
		minutes = 0;
		
	return hours, minutes;
}

// Method to decrement the time
int Time::decrementTime()
{
	// decreases hours by one digit
	hours--;
	
	if (hours < 1)
		hours = 0;
		
	// decreases minutes by one digit
	/* checks that if minutes less than 2
	and hours less than 24, minutes will 
	eaual 59, else minutes will equal zero*/
	if ((minutes < 2 && hours < 24))
		minutes = 0;
	else
		minutes--;
		
	return hours, minutes;
}