/* Specification:
Created/Revised by Barbara Williams on Septemeber 19, 2010
Ch. 13 Lab 3
This lab writes a program that contains a Time class that implements the time of day
in a program. Time class is extended to include a third data member in which time 
zone is stored. The derived class is called extTime with all the necessary function
definitions and constructors to make the class functional. The program includes a
test program (main) to test the inherited class features.*/

/* extTime.h the specification file for the class extTime contains four public
member functions and one private integer member variable.*/

// a preprocessor identifier means "if not defined EXTTIME_H"
#ifndef EXTTIME_H

// a preprocessor identifier means "defined EXTTIME_H"
#define EXTTIME_H

// derived class
class extTime:public Tim 
{
	public:
		/* default constructor that assigns a default value to the timeZone data
		member in the class*/
		extTime();
	
		/* overloaded constructor that takes three parameters and triggers 
		specifically the constructor from the base class */
		extTime(int, int, string);
		
		/* a new member function specific to the derived class, takes a character
		as a parameter and returns void */
		string setTimeZone(string);
		
		/* a constant overloaded method called printTime that takes no parameter,
		returns void and outputs the time including the time zone. It overrides 
		the parent class function, redefining the print member function of the 
		base class */
		void printTime() const;
		
	private:
		/* a new data member specific to the dervived class to hold the time zone, 
		this assumes the time zone is denoted by one character */
		string timeZone;
};

// a preprocessor identifier means "end if"
#endif
