/* Specification:
Created/Revised by Barbara Williams on Septemeber 19, 2010
Ch. 13 Lab 3
This lab writes a program that contains a Time class that implements the time of day
in a program. Time class is extended to include a third data member in which time 
zone is stored. The derived class is called extTime with all the necessary function
definitions and constructors to make the class functional. The program includes a
test program (main) to test the inherited class features.*/

/* extTimeImp.cpp, the implementation file of the derived class. The user program
that uses Time class */

// Time header file - Required by class
#include "Time.h"

// extTime header file - Required by class
#include "extTime.h"

//default constructor
extTime::extTime()
{
	// assigns a default value to timeZone data. This is Eastern time.
	timeZone = "EST"; one;
}

/* Overloaded constructor that takes three parameters and triggers specifically
the constructor from the base class. */
extTime::extTime(int hrs, int mins, string zone) : Time(hrs, mins)
{
	timeZone = zone;
}

// setTimezone method
string extTime::setTimeZone(string zone)
{
	timeZone = zone;
	return timeZone;
}

// override base class function with new implementation
void extTime::printTime() const
{
	//which will invoke the original printing function from the base class.
	Time::printTime();
	cout << " Time Zone = " << timeZone;
}
